################################################################################
# Test stage jobs
################################################################################

include:
  - component: gitlab.com/gitlab-org/components/danger-review/danger-review@~latest

test:go:
  stage: test
  needs: []
  extends:
    - .rules_dev_and_prod_no_upstream
  parallel:
    matrix:
      # Should match GO_VERSION_PREVIOUS and GO_VERSION variables declared in `.gitlab-ci.yml`
      - GO_VERSION: ["1.22", "1.23"]
  script:
    - make go-tests

test:jest:
  stage: test
  needs: []
  extends:
    - .frontend
    - .rules_dev_and_prod_no_upstream
  script:
    - apk add make
    - make jest-tests

test:markdown-links:
  stage: test
  extends:
    - .rules_docs
  image:
    name: lycheeverse/lychee:0.15.1-alpine
    entrypoint: [""]
  needs: []
  script:
    # See also markdown-link-tests in makefiles/Makefile.tests.mk
    - lychee --version
    - lychee --offline --include-fragments README.md doc/

# Check that asdf/mise dependencies install correctly
test:asdf-installation:
  stage: test
  extends:
    - .rules_asdf
  image: ${CI_DEPENDENCY_PROXY_DIRECT_GROUP_IMAGE_PREFIX}/debian:${DEBIAN_VERSION}-slim
  needs: []
  script:
    - apt-get update && apt-get install -y --no-install-recommends curl git jq make python3-pip xz-utils
    - git clone https://github.com/asdf-vm/asdf.git ~/.asdf --branch v${ASDF_VERSION}
    - source "$HOME/.asdf/asdf.sh"
    # Set PIP_BREAK_SYSTEM_PACKAGES=1 because we mix Debian-installed Python packages and other Python packages.
    - PIP_BREAK_SYSTEM_PACKAGES=1 make install-dependencies

# Check global navigation for:
#
# - Duplicate entries.
# - index.html in the entries.
# - Entries that don't conform to the schema.
# - Broken links.
#
check_global_nav_entries:
  stage: test
  extends:
    - .frontend
    - .rules_navigation
  needs: []
  script:
    - apk add --no-cache make bash
    - make check-global-navigation

# Check redirects amount is within supported threshold
test:check-redirect-threshold:
  extends:
    - .rules_dev_and_prod
  stage: validate-build
  needs:
    - build:compile_site
  script:
    - make check-redirect-threshold
  artifacts:
    paths:
      - public/_redirects
    expire_in: 1d
  allow_failure:
    exit_codes: 2
